function X=WF(k,N,n)
    X=k*ones(n+1,1);
    for i=1:n
        X(i+1)=grand(1,1,"bin",N,X(i)/N);
    end
endfunction

function X=WFmut(k,N,n,u,v)
    Q=zeros(N+1,N+1);
    for i=0:N
        for j=0:N
            Q(i+1,j+1)=(gamma(N+1)/(gamma(j+1)*gamma(N-j+1)))*(((1-u)*i/N+v*(1-i/N))^j)*((u*i/N+(1-v)*(1-i/N))^(N-j));
        end
    end
    X=[k+1,grand(n,'markov',Q,k)]';
    X=X-1;
endfunction

//La mesure invariante de WF est une uniforme sur {0,N} (qui sont des états absorbants). Il est évident que ce ne sera plus le cas ici. On peut simuler la loi limite de notre chaîne de Markov :

Nmax=10000;
n=30;
Zn=zeros(Nmax,1);
for N=1:Nmax
    Z=WFmut(4,10,n,0.3,0.4);
    Zn(N)=Z(length(Z));
end
histplot(floor(sqrt(Nmax)),Zn)