//EXERCICE 1

//Q.1.a.
    //Première façon de définir S_n en utilisant grand() :
function S=marche1(n)
    S=[0;cumsum(2*grand(n,1,'bin',1,0.5)-1)];
    //On notera que la marche aléatoire part de 0 à l'instant 0
endfunction

//Q.1.b.
    //Une autre façon, sans grand(), en utilisant rand() :
function S=marche1(n)
    X=rand(n,1);//X suit la loi uniforme sur [0,1]
    X=2*bool2s(X>0.5)-1;//X suit la loi de Rademacher
    S=[0;cumsum(X)];
endfunction

//Q.2.
    //Définition de S_n quand X suit une loi normale :
function S=marche2(n,s)
    S=[0;cumsum(grand(n,1,'nor',0,s^2))];
endfunction

//Q.3.
plot2d([0:50]',[marche2(50,2),marche2(50,2)],style=[2,5])
    //Encore une fois, faire partir les marches aléatoires de 0

//Q.4.
function F=interp(S,t)
    n=length(S)-1;
    l=floor(n*t);
    if l=n then
        F=S(l+1)/sqrt(n);
    else
    F=(S(l+1)+(n*t-l)*S(l+2))/sqrt(n);
    end
endfunction
    //Autre possibilité, pour rendre de meilleurs graphes :
n=100;
function plot_interp(S)
    n=length(S)-1;
    t=zeros(n+1,1);F=t;
    t=[0:n]'/n
    for k=0:n
      F(k+1)=S(k+1)/sqrt(n);
    end
    plot2d(t,F,style=2)
endfunction

//Q.5.
S=marche1(50)
plot_interp(S)

//Q.6.
S1=marche1(50);S2=marche1(100);S3=marche1(500);S4=marche1(1000);
plot_interp(S1)
plot_interp(S2)
plot_interp(S3)
plot_interp(S4)

//Q.7.a.
N=50000;//Taille d'échantillon N
clear F;
for i=1:N
    F(i)=interp(marche1(3000),0.5);//On arrête les marches aléatoires à l'instant n=3000
end
histplot(500,F)
stdev(F)^2
//On conjecture sans trop de risques une loi normale N(0,1/2)

//Q.7.b.
N=50000;
clear F;
for i=1:N
    F(i)=interp(marche1(3000),0.3);//On fait la même chose pour t=0.3
end
histplot(500,F)
stdev(F)^2
for i=1:N
    F(i)=interp(marche1(3000),0.8);//Idem pour t=0.8
end
histplot(500,F)
stdev(F)^2
//On conjecture donc une loi limite N(0,t)

//Q.8.
//L'objet limite vers lequel $F_n$ converge (en loi) est appelé mouvement brownien
//Nous illustons ici le théorème de Donsker : https://fr.wikipedia.org/wiki/Th%C3%A9or%C3%A8me_de_Donsker
